Debian Bug report logs - #549442
redmine: circular dependency hell

version graph

Package: redmine; Maintainer for redmine is Jérémy Lal <kapouer@melix.org>; Source for redmine is src:redmine.

Reported by: Bill Allombert <ballombe@debian.org>

Date: Sat, 3 Oct 2009 12:15:01 UTC

Severity: important

Found in version redmine/0.9.0~svn2902-1

Fixed in version redmine/0.9.0~svn2903-1

Done: Jérémy Lal <kapouer@melix.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Jérémy Lal <kapouer@melix.org>:
Bug#549442; Package redmine. (Sat, 03 Oct 2009 12:15:13 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <ballombe@debian.org>:
New Bug report received and forwarded. Copy sent to Jérémy Lal <kapouer@melix.org>. (Sat, 03 Oct 2009 12:15:13 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Bill Allombert <ballombe@debian.org>
To: submit@bugs.debian.org
Subject: redmine: circular dependency hell
Date: Sat, 3 Oct 2009 13:52:17 +0200
Package: redmine
Version: 0.9.0~svn2902-1
Severity: important

Hello Jérémy,

There is a circular dependency between redmine, redmine-mysql, redmine-pgsql and redmine-sqlite:

redmine 	:Depends: redmine-sqlite (= 0.9.0~svn2902-1), redmine-mysql (= 0.9.0~svn2902-1), redmine-pgsql (= 0.9.0~svn2902-1)
redmine-mysql 	:Depends: redmine
redmine-pgsql 	:Depends: redmine
redmine-sqlite 	:Depends: redmine

Complex circular dependencies are known to cause problems during upgrade, so we
should try to get rid of them.

See threads 
http://lists.debian.org/debian-devel/2005/06/msg02111.html
http://lists.debian.org/debian-devel/2005/11/msg01101.html

Cheers,
-- 
Bill. <ballombe@debian.org>

Imagine a large red swirl here. 




Information forwarded to debian-bugs-dist@lists.debian.org, Jérémy Lal <kapouer@melix.org>:
Bug#549442; Package redmine. (Sat, 03 Oct 2009 14:00:12 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jérémy Lal <jerry@edagames.com>:
Extra info received and forwarded to list. Copy sent to Jérémy Lal <kapouer@melix.org>. (Sat, 03 Oct 2009 14:00:12 GMT) Full text and rfc822 format available.

Message #10 received at 549442@bugs.debian.org (full text, mbox):

From: Jérémy Lal <jerry@edagames.com>
To: Bill Allombert <ballombe@debian.org>
Cc: Lucas Nussbaum <lucas@lucas-nussbaum.net>, 549442@bugs.debian.org
Subject: Re: Bug#549442: redmine: circular dependency hell
Date: Sat, 03 Oct 2009 15:38:09 +0200
On 03/10/2009 13:52, Bill Allombert wrote:
> Package: redmine
> Version: 0.9.0~svn2902-1
> Severity: important
>
> Hello Jérémy,
>
> There is a circular dependency between redmine, redmine-mysql, redmine-pgsql and redmine-sqlite:
>
> redmine 	:Depends: redmine-sqlite (= 0.9.0~svn2902-1), redmine-mysql (= 0.9.0~svn2902-1), redmine-pgsql (= 0.9.0~svn2902-1)
> redmine-mysql 	:Depends: redmine
> redmine-pgsql 	:Depends: redmine
> redmine-sqlite 	:Depends: redmine
>
> Complex circular dependencies are known to cause problems during upgrade, so we
> should try to get rid of them.
>
> See threads
> http://lists.debian.org/debian-devel/2005/06/msg02111.html
> http://lists.debian.org/debian-devel/2005/11/msg01101.html
>
> Cheers,
Thanks for the bug report,
1) does replacing Depends by Recommends is still considered a circular
dependency ?
2) if yes, would you hint me for deciding on which one i should break the
circular dependency ? redmine or redmine-<db> ?
Installing redmine alone most of the time leads to an unuseful installation,
while installing e.g. redmine-sqlite alone won't install anything, just dependencies.
My bet would be removing the dependency in the e.g. redmine-sqlite, but
i'm quite stuck with the chicken-or-egg myself :)

Jérémy Lal







Information forwarded to debian-bugs-dist@lists.debian.org, Jérémy Lal <kapouer@melix.org>:
Bug#549442; Package redmine. (Sat, 03 Oct 2009 15:03:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>:
Extra info received and forwarded to list. Copy sent to Jérémy Lal <kapouer@melix.org>. (Sat, 03 Oct 2009 15:03:06 GMT) Full text and rfc822 format available.

Message #15 received at 549442@bugs.debian.org (full text, mbox):

From: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
To: Jérémy Lal <jerry@edagames.com>
Cc: Lucas Nussbaum <lucas@lucas-nussbaum.net>, 549442@bugs.debian.org
Subject: Re: Bug#549442: redmine: circular dependency hell
Date: Sat, 3 Oct 2009 16:43:40 +0200
On Sat, Oct 03, 2009 at 03:38:09PM +0200, Jérémy Lal wrote:
> On 03/10/2009 13:52, Bill Allombert wrote:
>> Package: redmine
>> Version: 0.9.0~svn2902-1
>> Severity: important
>>
>> Hello Jérémy,
>>
>> There is a circular dependency between redmine, redmine-mysql, redmine-pgsql and redmine-sqlite:
>>
>> redmine 	:Depends: redmine-sqlite (= 0.9.0~svn2902-1), redmine-mysql (= 0.9.0~svn2902-1), redmine-pgsql (= 0.9.0~svn2902-1)
>> redmine-mysql 	:Depends: redmine
>> redmine-pgsql 	:Depends: redmine
>> redmine-sqlite 	:Depends: redmine
>>
>> Cheers,
> Thanks for the bug report,
> 1) does replacing Depends by Recommends is still considered a circular
> dependency ?

No, Recommends do not create 'dependencies'.

> Installing redmine alone most of the time leads to an unuseful installation,
> while installing e.g. redmine-sqlite alone won't install anything, just dependencies.
> My bet would be removing the dependency in the e.g. redmine-sqlite, but
> i'm quite stuck with the chicken-or-egg myself :)

Given that the redmine-db are only meta-packages, I would change
redmine to only Recommends redmine-sqlite|redmine-mysql|redmine-pgsql
(without version), and change the redmine-db to depend on the correct
version of redmine. There is not much point forcing user to install a
meta-package anyway.

Cheers,
Bill.




Information forwarded to debian-bugs-dist@lists.debian.org, Jérémy Lal <kapouer@melix.org>:
Bug#549442; Package redmine. (Sat, 03 Oct 2009 19:24:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
Extra info received and forwarded to list. Copy sent to Jérémy Lal <kapouer@melix.org>. (Sat, 03 Oct 2009 19:24:03 GMT) Full text and rfc822 format available.

Message #20 received at 549442@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
Cc: Jérémy Lal <jerry@edagames.com>, 549442@bugs.debian.org
Subject: Re: Bug#549442: redmine: circular dependency hell
Date: Sat, 3 Oct 2009 21:16:44 +0200
On 03/10/09 at 16:43 +0200, Bill Allombert wrote:
> On Sat, Oct 03, 2009 at 03:38:09PM +0200, Jérémy Lal wrote:
> > On 03/10/2009 13:52, Bill Allombert wrote:
> >> Package: redmine
> >> Version: 0.9.0~svn2902-1
> >> Severity: important
> >>
> >> Hello Jérémy,
> >>
> >> There is a circular dependency between redmine, redmine-mysql, redmine-pgsql and redmine-sqlite:
> >>
> >> redmine 	:Depends: redmine-sqlite (= 0.9.0~svn2902-1), redmine-mysql (= 0.9.0~svn2902-1), redmine-pgsql (= 0.9.0~svn2902-1)
> >> redmine-mysql 	:Depends: redmine
> >> redmine-pgsql 	:Depends: redmine
> >> redmine-sqlite 	:Depends: redmine
> >>
> >> Cheers,
> > Thanks for the bug report,
> > 1) does replacing Depends by Recommends is still considered a circular
> > dependency ?
> 
> No, Recommends do not create 'dependencies'.
> 
> > Installing redmine alone most of the time leads to an unuseful installation,
> > while installing e.g. redmine-sqlite alone won't install anything, just dependencies.
> > My bet would be removing the dependency in the e.g. redmine-sqlite, but
> > i'm quite stuck with the chicken-or-egg myself :)
> 
> Given that the redmine-db are only meta-packages, I would change
> redmine to only Recommends redmine-sqlite|redmine-mysql|redmine-pgsql
> (without version), and change the redmine-db to depend on the correct
> version of redmine. There is not much point forcing user to install a
> meta-package anyway.

No, that doesn't reflect the relationship between the packages
correctly.

redmine needs one of the 3 db packages to be installed. It wouldn't be
functional without one of them installed. Depends: is the correct
relationship.

redmine-[db] packages only provide the dependencies, but not providing a
working redmine installation when they are installed is misleading
for the user. (one would expect redmine to work when redmine-sqlite is
installed, for example).

Is it still true that circular dependencies cause problems during
upgrades? I mean, there are lots of circular dependencies in the
archive, and the only problem I've heard of is with piuparts, whose
dependencies analyzer isn't particularly well written.

Also, the solution to make redmine only recommends: redmine-db* is
clearly wrong, and should not be chosen. The most correct solution would
be to drop the dependency in redmine-db*, and make it crystal clear (in
the description) that those packages only provide the list of deps.
-- 
| Lucas Nussbaum
| lucas@lucas-nussbaum.net   http://www.lucas-nussbaum.net/ |
| jabber: lucas@nussbaum.fr             GPG: 1024D/023B3F4F |




Information forwarded to debian-bugs-dist@lists.debian.org, Jérémy Lal <kapouer@melix.org>:
Bug#549442; Package redmine. (Sun, 04 Oct 2009 19:39:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>:
Extra info received and forwarded to list. Copy sent to Jérémy Lal <kapouer@melix.org>. (Sun, 04 Oct 2009 19:39:02 GMT) Full text and rfc822 format available.

Message #25 received at 549442@bugs.debian.org (full text, mbox):

From: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
To: Lucas Nussbaum <lucas@lucas-nussbaum.net>
Cc: Jérémy Lal <jerry@edagames.com>, 549442@bugs.debian.org
Subject: Re: Bug#549442: redmine: circular dependency hell
Date: Sun, 4 Oct 2009 21:34:46 +0200
On Sat, Oct 03, 2009 at 09:16:44PM +0200, Lucas Nussbaum wrote:
> No, that doesn't reflect the relationship between the packages
> correctly.
> 
> redmine needs one of the 3 db packages to be installed. It wouldn't be
> functional without one of them installed. Depends: is the correct
> relationship.

Well, it technically does not: if you install redmine-mysql and then remove it,
redmine will still continue to work as before, but I see your point.  

> Is it still true that circular dependencies cause problems during
> upgrades? I mean, there are lots of circular dependencies in the

Yes, but since there is much less circular dependencies than in Sarge,
we see less problems. See the number of circular dependency in realtime
<http://debian.semistable.com/progress.png> (about 65 today). Note that the
ratio nb of circular dependency/nb of packages has dropped much more than what
the graph tell.

> archive, and the only problem I've heard of is with piuparts, whose
> dependencies analyzer isn't particularly well written.

I think piupart simply use 'apt-get dist-upgrade -f'

> Also, the solution to make redmine only recommends: redmine-db* is
> clearly wrong, and should not be chosen. The most correct solution would
> be to drop the dependency in redmine-db*, and make it crystal clear (in
> the description) that those packages only provide the list of deps.

This is another way, but that might require to rename the remine-db packages,
which is anoying.

Cheers,
-- 
Bill. <ballombe@debian.org>

Imagine a large red swirl here. 




Information forwarded to debian-bugs-dist@lists.debian.org, Jérémy Lal <kapouer@melix.org>:
Bug#549442; Package redmine. (Sun, 04 Oct 2009 19:57:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
Extra info received and forwarded to list. Copy sent to Jérémy Lal <kapouer@melix.org>. (Sun, 04 Oct 2009 19:57:08 GMT) Full text and rfc822 format available.

Message #30 received at 549442@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: Bill Allombert <Bill.Allombert@math.u-bordeaux1.fr>
Cc: Jérémy Lal <jerry@edagames.com>, 549442@bugs.debian.org
Subject: Re: Bug#549442: redmine: circular dependency hell
Date: Sun, 4 Oct 2009 21:49:01 +0200
On 04/10/09 at 21:34 +0200, Bill Allombert wrote:
> > archive, and the only problem I've heard of is with piuparts, whose
> > dependencies analyzer isn't particularly well written.
> 
> I think piupart simply use 'apt-get dist-upgrade -f'

The part of piuparts that chooses which package to test next (on
piuparts.d.o) does that based on a dependency analyzer written from
scratch in python.

> > Also, the solution to make redmine only recommends: redmine-db* is
> > clearly wrong, and should not be chosen. The most correct solution would
> > be to drop the dependency in redmine-db*, and make it crystal clear (in
> > the description) that those packages only provide the list of deps.
> 
> This is another way, but that might require to rename the remine-db packages,
> which is anoying.

Well, that's the only way, no?
-- 
| Lucas Nussbaum
| lucas@lucas-nussbaum.net   http://www.lucas-nussbaum.net/ |
| jabber: lucas@nussbaum.fr             GPG: 1024D/023B3F4F |




Added tag(s) pending. Request was from Jérémy Lal <kapouer@melix.org> to control@bugs.debian.org. (Mon, 05 Oct 2009 13:36:10 GMT) Full text and rfc822 format available.

Reply sent to Jérémy Lal <kapouer@melix.org>:
You have taken responsibility. (Thu, 08 Oct 2009 20:00:19 GMT) Full text and rfc822 format available.

Notification sent to Bill Allombert <ballombe@debian.org>:
Bug acknowledged by developer. (Thu, 08 Oct 2009 20:00:19 GMT) Full text and rfc822 format available.

Message #37 received at 549442-close@bugs.debian.org (full text, mbox):

From: Jérémy Lal <kapouer@melix.org>
To: 549442-close@bugs.debian.org
Subject: Bug#549442: fixed in redmine 0.9.0~svn2903-1
Date: Thu, 08 Oct 2009 19:32:16 +0000
Source: redmine
Source-Version: 0.9.0~svn2903-1

We believe that the bug you reported is fixed in the latest version of
redmine, which is due to be installed in the Debian FTP archive:

redmine-mysql_0.9.0~svn2903-1_all.deb
  to pool/main/r/redmine/redmine-mysql_0.9.0~svn2903-1_all.deb
redmine-pgsql_0.9.0~svn2903-1_all.deb
  to pool/main/r/redmine/redmine-pgsql_0.9.0~svn2903-1_all.deb
redmine-sqlite_0.9.0~svn2903-1_all.deb
  to pool/main/r/redmine/redmine-sqlite_0.9.0~svn2903-1_all.deb
redmine_0.9.0~svn2903-1.diff.gz
  to pool/main/r/redmine/redmine_0.9.0~svn2903-1.diff.gz
redmine_0.9.0~svn2903-1.dsc
  to pool/main/r/redmine/redmine_0.9.0~svn2903-1.dsc
redmine_0.9.0~svn2903-1_all.deb
  to pool/main/r/redmine/redmine_0.9.0~svn2903-1_all.deb
redmine_0.9.0~svn2903.orig.tar.gz
  to pool/main/r/redmine/redmine_0.9.0~svn2903.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 549442@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Jérémy Lal <kapouer@melix.org> (supplier of updated redmine package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Thu, 08 Oct 2009 18:59:18 +0200
Source: redmine
Binary: redmine redmine-mysql redmine-pgsql redmine-sqlite
Architecture: source all
Version: 0.9.0~svn2903-1
Distribution: unstable
Urgency: low
Maintainer: Jérémy Lal <kapouer@melix.org>
Changed-By: Jérémy Lal <kapouer@melix.org>
Description: 
 redmine    - flexible project management web application
 redmine-mysql - metapackage providing MySQL dependencies for Redmine
 redmine-pgsql - metapackage providing PostgreSQL dependencies for Redmine
 redmine-sqlite - metapackage providing sqlite dependencies for Redmine
Closes: 549442
Changes: 
 redmine (0.9.0~svn2903-1) unstable; urgency=low
 .
   * Upstream update.
   * Removes circular dependencies (Closes: #549442)
   * Session cookies path should respect RAILS_RELATIVE_URL_ROOT env variable.
   * Add folder for proper initialization of some plugins.
Checksums-Sha1: 
 bf8bbd6552ed8022293f9e83fac92feebcc00579 1334 redmine_0.9.0~svn2903-1.dsc
 cc15b47e83783fc3a89b4fdcf6a5667f99ea057a 1307589 redmine_0.9.0~svn2903.orig.tar.gz
 279a8d6b32741cb15677cebcf7dfcbaaba74b815 48371 redmine_0.9.0~svn2903-1.diff.gz
 47a3f621c52df7e9e133ce1cf363c055475bfbd1 1067586 redmine_0.9.0~svn2903-1_all.deb
 5b775bde2ddf3d913c3a1855d3fed9184d2eeebb 3330 redmine-mysql_0.9.0~svn2903-1_all.deb
 6877349fa77d2339a736f200d95814997d69a5b9 3322 redmine-pgsql_0.9.0~svn2903-1_all.deb
 98bb9b7214decd6b44f7dca6f5e0f83aa68972e1 3298 redmine-sqlite_0.9.0~svn2903-1_all.deb
Checksums-Sha256: 
 5cf1ceea334742e2be8e352dbb65c080ffec14f3bac551700aae2083f9f461fc 1334 redmine_0.9.0~svn2903-1.dsc
 b9e4bc77a4ad0fccca11aae66fa7b05d0c9cdea1476101b95171a528dcc0e452 1307589 redmine_0.9.0~svn2903.orig.tar.gz
 7dbe7b581992ba171570252c99311f662d5a7576e3cfcb56ed5d706b25884e9b 48371 redmine_0.9.0~svn2903-1.diff.gz
 8416a5a1c69fdec9792ec567339272d7c1d60095d3aff1f89d92dfb56d696542 1067586 redmine_0.9.0~svn2903-1_all.deb
 50f75fb8c870674062923e5540a090685ddf8d2e7c5b36123336bd46f62ff594 3330 redmine-mysql_0.9.0~svn2903-1_all.deb
 15d9d9d85622d658f43125fddb2f5fc11baed8f412e119857ca192578c363d85 3322 redmine-pgsql_0.9.0~svn2903-1_all.deb
 9ab4f36db9a61060f74c3857800dbbb5ad919ff48a92f7da850b2b68d07cd39d 3298 redmine-sqlite_0.9.0~svn2903-1_all.deb
Files: 
 92ec9e5fbafe07de584ea1f1ac794bc8 1334 web extra redmine_0.9.0~svn2903-1.dsc
 be793f90df2d3da5c64f49e1a070162c 1307589 web extra redmine_0.9.0~svn2903.orig.tar.gz
 7f998c57b799980743409bc4221bdf65 48371 web extra redmine_0.9.0~svn2903-1.diff.gz
 b8adc54f25bd27a2ad97a427f174db70 1067586 web extra redmine_0.9.0~svn2903-1_all.deb
 ee76aceb396a76fa9f46e849a05c45b8 3330 web extra redmine-mysql_0.9.0~svn2903-1_all.deb
 c07fab6da2e3c48a4931eff6eec26efd 3322 web extra redmine-pgsql_0.9.0~svn2903-1_all.deb
 7a1eee3e2b51d735564d5059968baf8d 3298 web extra redmine-sqlite_0.9.0~svn2903-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iD8DBQFKzjy82hliNwI7P08RAom7AJ4xE6Ls2a75tDtEX/CyevdKXgWZUwCgmmE5
Yzh7iJtdRI+BmKIxWrHFXP4=
=dEtl
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 06 Nov 2009 07:38:43 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 21:08:54 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.